package com.utopiaindustries.hseobservationsapp.activities.ObservationForms;

import static com.utopiaindustries.hseobservationsapp.R.*;

import android.Manifest;
import android.annotation.SuppressLint;
import android.content.ActivityNotFoundException;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.activity.EdgeToEdge;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.FileProvider;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.bumptech.glide.Glide;
import com.bumptech.glide.request.RequestOptions;
import com.utopiaindustries.hseobservationsapp.R;
import com.utopiaindustries.hseobservationsapp.activities.DashboardActivity;
import com.utopiaindustries.hseobservationsapp.activities.LoginActivity;
import com.utopiaindustries.hseobservationsapp.adapters.DepartmentAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationClassAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.ObservationSubClassAdapter;
import com.utopiaindustries.hseobservationsapp.adapters.RiskLevelAdapter;
import com.utopiaindustries.hseobservationsapp.models.Department;
import com.utopiaindustries.hseobservationsapp.models.Shift;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.function.Consumer;

import pub.devrel.easypermissions.AfterPermissionGranted;
import pub.devrel.easypermissions.AppSettingsDialog;
import pub.devrel.easypermissions.EasyPermissions;

public class ObservationTwoActivity extends AppCompatActivity implements EasyPermissions.PermissionCallbacks,
        EasyPermissions.RationaleCallbacks{

    private Button btnNext;
    ImageView imgBack;
    ImageView imgBefore, beforeCrossButton, imgAfter, afterCrossButton;
    private AutoCompleteTextView departmentTextview, riskLevelTextview;

    private DepartmentAdapter departmentAdapter;
    private RiskLevelAdapter riskLevelAdapter;

    private ArrayList<Shift> departmentArrayList = new ArrayList<>();
    private ArrayList<Shift> riskLevelArrayList = new ArrayList<>();

    private static final int CAMERA_REQUEST = 100;
    private static final int GALLERY_REQUEST = 200;

    String filePathBefore = "no_pic";
    String filePathAfter = "no_pic";

    String imgType = "";

    // Activity Result Launcher for Gallery
    private final ActivityResultLauncher<Intent> imagePickerLauncher =
            registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {
                if (result.getResultCode() == RESULT_OK && result.getData() != null) {
                    Uri selectedImage = result.getData().getData();

                    if (imgType.equalsIgnoreCase("before")) {

                        uriToByteArrayAsync(
                                this,
                                selectedImage,
                                100,  // Target size in KB
                                compressedImage -> {
                                    // Handle the compressed image here, e.g., display it
                                    runOnUiThread(() -> {
                                        Glide.with(this)
                                                .load(compressedImage) // Glide will handle the decoding and placeholder
                                                .placeholder(R.drawable.img_load)
                                                .apply(new RequestOptions().centerCrop())
                                                .into(imgBefore);
                                    });
                                },
                                error -> {
                                    // Handle any errors
                                    runOnUiThread(() -> {
                                        Toast.makeText(this, "Error compressing image: " + error.getMessage(), Toast.LENGTH_SHORT).show();
                                    });
                                }
                        );

                    }
                    else {
                        uriToByteArrayAsync(
                                this,
                                selectedImage,
                                100,  // Target size in KB
                                compressedImage -> {
                                    // Handle the compressed image here, e.g., display it
                                    runOnUiThread(() -> {
                                        Glide.with(this)
                                                .load(compressedImage) // Glide will handle the decoding and placeholder
                                                .placeholder(R.drawable.img_load)
                                                .apply(new RequestOptions().centerCrop())
                                                .into(imgAfter);
                                    });
                                },
                                error -> {
                                    // Handle any errors
                                    runOnUiThread(() -> {
                                        Toast.makeText(this, "Error compressing image: " + error.getMessage(), Toast.LENGTH_SHORT).show();
                                    });
                                }
                        );
                    }
                }
                else if (result.getResultCode() == RESULT_CANCELED) {
                    Toast.makeText(this, "Gallery Selection Cancelled!", Toast.LENGTH_SHORT).show();
                }
                else {
                    Toast.makeText(this, "Gallery Selection Cancelled!", Toast.LENGTH_SHORT).show();
                }
            });

    // Activity Result Launcher for Camera
    private final ActivityResultLauncher<Intent> cameraLauncher =
            registerForActivityResult(new ActivityResultContracts.StartActivityForResult(), result -> {

                if (result.getResultCode() == RESULT_OK) {

                    if (imgType.equalsIgnoreCase("before")) {
                        Uri contentUri = Uri.fromFile(new File((filePathBefore)));

                        uriToByteArrayAsync(
                                this,
                                contentUri,
                                100,  // Target size in KB
                                compressedImage -> {
                                    // Handle the compressed image here, e.g., display it
                            runOnUiThread(() -> {
                                Glide.with(this)
                                        .load(contentUri) // Glide will handle the decoding and placeholder
                                        .placeholder(R.drawable.img_load)
                                        .apply(new RequestOptions().centerCrop())
                                        .into(imgBefore);
                            });
                                },
                                error -> {
                                    // Handle any errors
                                    runOnUiThread(() -> {
                                        Toast.makeText(this, "Error compressing image: " + error.getMessage(), Toast.LENGTH_SHORT).show();
                                    });
                                }
                        );
                    }
                    else {
                        Uri contentUri = Uri.fromFile(new File((filePathAfter)));

                        uriToByteArrayAsync(
                                this,
                                contentUri,
                                100,  // Target size in KB
                                compressedImage -> {
                                    // Handle the compressed image here, e.g., display it
                            runOnUiThread(() -> {
                                Glide.with(this)
                                        .load(contentUri) // Glide will handle the decoding and placeholder
                                        .placeholder(R.drawable.img_load)
                                        .apply(new RequestOptions().centerCrop())
                                        .into(imgAfter);
                            });
                                },
                                error -> {
                                    // Handle any errors
                                    runOnUiThread(() -> {
                                        Toast.makeText(this, "Error compressing image: " + error.getMessage(), Toast.LENGTH_SHORT).show();
                                    });
                                }
                        );
                    }
                }
                else if (result.getResultCode() == RESULT_CANCELED) {
                    Toast.makeText(this, "Camera capture failed!", Toast.LENGTH_SHORT).show();
                }
                else {
                    Toast.makeText(this, "Camera capture failed!", Toast.LENGTH_SHORT).show();
                }
            });

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_observation_two);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initializeLayout();

        imgBack.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        btnNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(ObservationTwoActivity.this, ObservationThreeActivity.class);
                startActivity(intent);
            }
        });

        imgBefore.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgType = "before";
                alertForPictures(ObservationTwoActivity.this);
            }
        });

        imgAfter.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgType = "after";
                alertForPictures(ObservationTwoActivity.this);
            }
        });

        beforeCrossButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgBefore.setImageResource(R.drawable.icon_image);
            }
        });

        afterCrossButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                imgAfter.setImageResource(R.drawable.icon_image);
            }
        });

        departmentTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

            }
        });

        riskLevelTextview.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

            }
        });
    }

    private void initializeLayout() {

        btnNext = findViewById(R.id.btn_next);
        imgBack = findViewById(R.id.img_back);

        imgBefore = findViewById(R.id.img_before);
        imgAfter = findViewById(R.id.img_after);

        beforeCrossButton = findViewById(R.id.before_cross_button);
        afterCrossButton = findViewById(R.id.after_cross_button);

        departmentTextview = findViewById(R.id.department_textview);
        riskLevelTextview = findViewById(R.id.risk_textview);

        departmentAdapter = new DepartmentAdapter(this, departmentArrayList);
        departmentTextview.setAdapter(departmentAdapter);

        riskLevelAdapter = new RiskLevelAdapter(this, riskLevelArrayList);
        riskLevelTextview.setAdapter(riskLevelAdapter);
    }

    @SuppressLint("MissingInflatedId")
    public void alertForPictures(Context con) {
        ViewGroup viewGroup = findViewById(android.R.id.content);

        TextView dialogCameraBtn, dialogGalleryBtn;

        AlertDialog.Builder builder = new AlertDialog.Builder(con);
        View view1 = LayoutInflater.from(con).inflate(R.layout.custom_layout_for_image, viewGroup, false);
        builder.setCancelable(false);
        builder.setView(view1);

        dialogCameraBtn = view1.findViewById(R.id.dialog_camera_btn);
        dialogGalleryBtn = view1.findViewById(R.id.dialog_gallery_btn);

        AlertDialog alertDialog = builder.create();
        alertDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));

        dialogCameraBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();
                openCamera();

            }
        });

        dialogGalleryBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                alertDialog.dismiss();
                openGallery();

            }
        });

        alertDialog.show();
    }

    @AfterPermissionGranted(CAMERA_REQUEST)
    public void openCamera() {
        if (hasCameraPermission()) {
            try {
                Intent takePictureIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
                File photoFile = null;
                try {
                    photoFile = createImageFile(imgType);
                } catch (IOException ex) {
                    // Error occurred while creating the File
                }

                if (photoFile != null) {
                    Uri photoURI = FileProvider.getUriForFile(this,
                            "com.utopiaindustries.hseobservationsapp",
                            photoFile);
                    takePictureIntent.putExtra(MediaStore.EXTRA_OUTPUT, photoURI);
                    //startActivityForResult(takePictureIntent, CAMERA_REQUEST);
                    cameraLauncher.launch(takePictureIntent);
                }
            } catch (ActivityNotFoundException e) {
                Toast.makeText(this, "Camera app not found", Toast.LENGTH_SHORT).show();
            }
        } else {
            // Ask for one permission
            String[] perms = {};
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES, Manifest.permission.CAMERA};
            } else {
                perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA};
            }

            EasyPermissions.requestPermissions(this, getString(R.string.rationale_camera), CAMERA_REQUEST, perms);
        }
    }

    @AfterPermissionGranted(GALLERY_REQUEST)
    public void openGallery() {
        if (hasGalleryPermission()) {
            // Have permission, do the thing!
            Intent galleryIntent = new Intent(Intent.ACTION_PICK, android.provider.MediaStore.Images.Media.EXTERNAL_CONTENT_URI);
            // Start the Intent
            //startActivityForResult(galleryIntent, GALLERY_REQUEST);
            imagePickerLauncher.launch(galleryIntent);
        } else {
            // Ask for one permission
            String[] perms = {};
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES};
            } else {
                perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE};

            }
            EasyPermissions.requestPermissions(this, getString(R.string.rationale_gallery), GALLERY_REQUEST, perms);
        }
    }

    private boolean hasGalleryPermission() {
        String[] perms = {};

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES};
        } else {
            perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE};
        }

        return EasyPermissions.hasPermissions(this, perms);
    }

    private boolean hasCameraPermission() {
        String[] perms = {};
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
            //Log.e("TIRAMISU: ","***");
            perms = new String[]{Manifest.permission.READ_MEDIA_IMAGES, Manifest.permission.CAMERA};
        } else {
            //Log.e("Not-TIRAMISU: ","***");
            perms = new String[]{Manifest.permission.READ_EXTERNAL_STORAGE, Manifest.permission.WRITE_EXTERNAL_STORAGE, Manifest.permission.CAMERA};

        }

        //Log.e("perms: ",""+perms);
        return EasyPermissions.hasPermissions(this, perms);
    }

    private File createImageFile(String imgType) throws IOException {
        // Create an image file name
        String timeStamp = new SimpleDateFormat("yyyyMMdd_HHmmss").format(new Date());
        String imageFileName = "JPEG_" + timeStamp + "_";
        File storageDir = getExternalFilesDir(Environment.DIRECTORY_PICTURES);
        File image = File.createTempFile(
                imageFileName,  /* prefix */
                ".jpg",         /* suffix */
                storageDir      /* directory */
        );

        if (imgType.equals("before")) {
            filePathBefore = image.getAbsolutePath();
        }
        else {
            filePathAfter = image.getAbsolutePath();
        }

        return image;
    }

    public void uriToByteArrayAsync(
            Context context,
            Uri uri,
            int targetSizeInKB,
            Consumer<byte[]> onSuccess,
            Consumer<Exception> onError
    ) {
        new Thread(() -> {
            try {
                int targetSizeInBytes = targetSizeInKB * 1024;

                // Load the image as a Bitmap without scaling
                Bitmap bitmap;
                try (InputStream inputStream = context.getContentResolver().openInputStream(uri)) {
                    bitmap = BitmapFactory.decodeStream(inputStream);
                }

                if (bitmap == null) {
                    throw new IOException("Failed to decode image from URI.");
                }

                ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
                int minQuality = 10;
                int maxQuality = 100;
                int quality = maxQuality;

                // Binary search for the best quality that meets the target size
                while (minQuality <= maxQuality) {
                    byteArrayOutputStream.reset();
                    bitmap.compress(Bitmap.CompressFormat.JPEG, quality, byteArrayOutputStream);

                    int byteSize = byteArrayOutputStream.size();
                    if (byteSize > targetSizeInBytes) {
                        maxQuality = quality - 1;
                    } else {
                        minQuality = quality + 1;
                    }
                    quality = (minQuality + maxQuality) / 2;
                }

                onSuccess.accept(byteArrayOutputStream.toByteArray());
            } catch (IOException e) {
                onError.accept(e);
            }
        }).start();
    }

    @Override
    public void onPermissionsGranted(int requestCode, @NonNull List<String> perms) {

    }

    @Override
    public void onPermissionsDenied(int requestCode, @NonNull List<String> perms) {
        if (EasyPermissions.somePermissionPermanentlyDenied(this, perms)) {
            new AppSettingsDialog.Builder(this).build().show();
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String[] permissions,
                                           @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        // EasyPermissions handles the request result.
        EasyPermissions.onRequestPermissionsResult(requestCode, permissions, grantResults, this);
    }

    @Override
    public void onRationaleAccepted(int requestCode) {

    }

    @Override
    public void onRationaleDenied(int requestCode) {

    }
}